#!/usr/bin/perl
#########################################################################
#
# Hash a 419 letter by word frequency.
#
# $Id: makeBaseHashLib.pl,v 1.4 2005/03/02 17:09:29 devel Exp $
#
#########################################################################
#
#    Copyright 2005 Charles Shapiro 
#    This file is part of the Fraudulator.
#
#    The Fraudulator is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    The Fraudulator is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with the Fraudulator; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#############################################################################
use strict;
use Getopt::Std;

use FourNineTeen;
use vars qw($opt_i $opt_o $opt_l $opt_u);

sub usage($)
{
    print("Usage: $_[0] -i infile -o outfile -l lowerbound -u upperbound\n");
    print<<EOU
	Make  a word-frequency hash  of the text in infile to stdout.
	Include only words with frequencies between lowerbound and 
        upperbound if given. 
EOU
}

#
# Main Line 
#
$opt_l=0;
$opt_u=-1;

if(! getopts("o:i:l:u:"))
{
    usage($0);
    die;
}
if (! $opt_o)
{
    usage($0);
    die;
}
if(! $opt_i)
{
    usage($0);
    die;
}

my $letterSize;
my %newHash = makeHash($opt_i,\$letterSize);
# print("Letter: ", $opt_i," Size: ",$letterSize,"\n");
printHashList($opt_o,$opt_u,$opt_l,%newHash);













