#!/bin/bash

usage ()
{
    echo Usage: $1 {-d}
    cat <<EOU 
    Run the makeBaseHashLib perl script with some plausible arguments.
    Pass the d switch to run it with debug turned on.
    $Id: rmakeBaseHashLib.sh,v 1.1 2005/03/01 15:58:27 devel Exp $
EOU
}

TEMP=`getopt -- "d" $@`
if [ $? != 0 ]
then
    usage $0
    exit 1
fi

eval set -- "$TEMP"

while true
do
    case "$1" in    
	-d) DEBUG=" -d " ; shift;;
	--) shift ; break;;
	*)  echo Oops. ; exit 1 ;;
    esac
done

perl $DEBUG ./makeBaseHashLib.pl -i mail.2273 -o mail.2273.hash -l 4 -u 80
