#!/usr/bin/perl
###############################################################################
#
# Create a hash vector by words. Given a global word hash and a letter file,
# produce a number consisting of the position in the global hash of each 
# word in the letter corresponding to a word in the global hash.
#
# $Id: hashVecLib.pl,v 1.4 2005/03/01 17:48:52 devel Exp $
#
#############################################################################
#
#    Copyright 2005 Charles Shapiro 
#    This file is part of the Fraudulator.
#
#    The Fraudulator is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    The Fraudulator is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with the Fraudulator; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#############################################################################
# use lib ("../419Lib");
use strict;
use Getopt::Std;
use FourNineTeen;

use vars qw( %GlobalHash %WordHash $opt_h $opt_i); 

#
# Usage Message
#
sub usage($)
{
    print("Usage: $_[0] -h hashfile -i infile\n");
    print<<EOU
        Print the hash vector between infile and hashfile 
EOU
}

#
# Main Line
#

if (! getopts("i:h:"))
{
    usage($0);
    die;
}
if (! $opt_i)
{
    usage($0);
    die("No -i infile\n");
}
if(! $opt_h)
{
    usage($0);
    die("No -h hashfile\n");
}
%GlobalHash = read_hashfile($opt_h);
if (! %GlobalHash)
{
    die("Cannot read hashfile $opt_h");
}

# printHash(%GlobalHash);
my $letterSize;
%WordHash=makeHash($opt_i,\$letterSize);
# printHash(%WordHash);
print(makeHashVector(\%GlobalHash,\%WordHash,$letterSize));
print("\t",$opt_i,"\n");

