#!/usr/bin/perl
###############################################################################
#
# Create a hash vector by words. Given a global word hash and a letter file,
# produce a number consisting of the position in the global hash of each 
# word in the letter corresponding to a word in the global hash.
#
###############################################################################
use lib ("../419Lib");
use strict;
use Getopt::Std;
use FourNineTeen;

use vars qw(%GlobalHash %WordHash $opt_h $opt_i);

#
# Usage Message
#
sub usage($)
{
    print("Usage: $_[0] -h hashfile -i infile\n");
    print<<EOU
        Print the hash vector between infile and hashfile
EOU
}


#
# Main Line
#

if (! getopts("i:h:"))
{
    usage($0);
    die;
}
if (! $opt_i)
{
    usage($0);
    die("No -i infile\n");
}
if(! $opt_h)
{
    usage($0);
    die("No -h hashfile\n");
}
%GlobalHash = read_hashfile($opt_h);
if (! %GlobalHash)
{
    die("Cannot read hashfile $opt_h");
}

# printHash(%GlobalHash);
my $hashPrintSize=getHashPrintSize(%GlobalHash);
# print("HashPrintSize: ",$hashPrintSize,"\n");


%WordHash=makeHash($opt_i);
# printHash(%WordHash);
my $hashVecKey;
foreach $hashVecKey (sort keys %WordHash)
{
    if(defined $GlobalHash{$hashVecKey})
    {
	printf("%0*d",$hashPrintSize,$GlobalHash{$hashVecKey});
    }
}
print("\t",$opt_i,"\n");







