#!/bin/bash
##########################################################################
#
# Set this directory set up for testing after cvs checkout -- 
# make symlinks, et cetera.
#
# $Id: setup.sh,v 1.5 2005/02/08 17:10:57 devel Exp $
#
##########################################################################
#    Copyright 2005 Charles Shapiro 
#    This file is part of the Fraudulator.
#
#    The Fraudulator is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    The Fraudulator is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with the Fraudulator; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
##############################################################################

# set -x

checkLink ()
{
    if [ -h $2 ]
    then
	rm -f $2
    fi
    ln -s $1 $2
}

#
# Main Line
#
if [ $# -gt 0 -a $1 = "nofiles" ]
then
    echo Assuming you already have files in ./files.
else
    FOURNINETEENFILES="${HOME}/419/files"
    # checkLink ${FOURNINETEENFILES} ./files
    mkdir files
    cp ${FOURNINETEENFILES}/mail.24* files
    cp ${FOURNINETEENFILES}/mail.23* files
fi
# Set up symlinks
LIBFILEDIR="`pwd`/419Lib"
LIBFILE="FourNineTeen.pm"

checkLink ${LIBFILEDIR}/${LIBFILE} base_hash/${LIBFILE}
checkLink ${LIBFILEDIR}/${LIBFILE} hash_finder/${LIBFILE}
checkLink ${LIBFILEDIR}/${LIBFILE} hash_vector/${LIBFILE}

# Set up for running tests.
ALLMAILS=allmails.txt
if [ -f ${ALLMAILS} ]
then
    rm ${ALLMAILS}
fi

for ii in files/*
do
    cat $ii >> ${ALLMAILS}
done

LOWERBOUND=10
UPPERBOUND=300
BIGHASH="hash${LOWERBOUND}-${UPPERBOUND}.txt"
HASHLIST="hashes.list"
if [ -f ${BIGHASH} ]
then
    rm -f ${BIGHASH}
fi
if [ -f ${HASHLIST} ]
then
    rm -f ${HASHLIST}
fi
if [ -f ${HASHLIST}.no2321 ]
then
    rm -f ${HASHLIST}.no2321
fi
pushd base_hash
makeBaseHashLib.pl -i ../${ALLMAILS} -o ../${BIGHASH} -l ${LOWERBOUND} -u ${UPPERBOUND}
popd
pushd hash_vector
doHashVecs.sh ../${BIGHASH} ../${HASHLIST}
popd
grep -v "mail.2321" ${HASHLIST} > ${HASHLIST}.no2321
checkLink `pwd`/${BIGHASH} hash_finder/hashes.in











