#! /usr/bin/perl
###############################################################################
#
# Search for a 419 letter by hash key in a database.
# Hacked from:
# formtest.cgi by David Efflandt (efflandt@xnet.com)
# Charles Shapiro 3 Jan 2005
#

# $Id: findletter.pl,v 1.11 2005/03/16 16:21:10 devel Exp $
#
###############################################################################
#
#    Copyright 2005 Charles Shapiro 
#    This file is part of the Fraudulator.
#
#    The Fraudulator is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    The Fraudulator is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with the Fraudulator; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#############################################################################


use strict;
use FourNineTeen;
use File::Basename;
#
# usage message
#
sub usage($)
{
        print("Content-type: text/html\n\n");
	print("oops. Configuration error.\n");	
}
#
# Error (such as size too big.)
#
sub print_error($)
{
    print("Content-type: text/html\n\n");
    print("<html>\n<body>\n<h1>Error</h1>\n");
    print($_[0]);
    print("</body></html>\n");
}
#
# Form variable into hash list.
#
sub makeDataList($) {

    my $buffer=$_[0];
  # Split the name-value pairs
    my @pairs = split(/&/, $buffer);
    my $pair;
    my $name;
    my $value;
    my %retList;

    foreach $pair (@pairs) 
    {
	($name, $value) = split(/=/, $pair);
	
	$value =~ tr/+/ /;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$name =~ tr/+/ /;
	$name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$retList{$name}=$value;
    }
    %retList;
}

#
# Print HTML header.
#
sub printHTMLHeader($)
{
    my $listsize=$_[0];
    # HTML header
    print("Content-type: text/html\n\n");
    print("<!DOCTYPE HTML PUBLIC \"-//W3C/DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\">\n");
    print("<html>\n");
# This does not work and I do not know why.
    print("<link href=\"webstyle.css\" rel=\"stylesheet\" type=\"text/css\">\n");
    print("<head><title>Fraudulator Results</title></head>\n");
    print("<body>\n");
    print("<h1>Fraudulator Results</h1>\n");
    print("Size: ",$listsize,"<br>\n"); 

}

sub printHTMLFooter()
{
    print("\n</body>");
    print("\n</html>");
}
#
# Main Line
#

my $inBuffer;
if ($#ARGV == -1 )
{
    my $contLength=$ENV{'CONTENT_LENGTH'};
    # Accept a maximum of 40K of text.
    if ($contLength > 40960)
    {
	print_error("Oops. I only accept text smaller than 40K.");
	exit 0;
    }
    read(STDIN,$inBuffer,$contLength);
}
else
{
    open(INPUT,"<$ARGV[0]");
    $inBuffer=<INPUT>;
    close(INPUT);
}

my %postedPairs=makeDataList($inBuffer);
printHTMLHeader($postedPairs{"resultsize"});

my %allHashes = read_hashfile($postedPairs{"HashFile"});
if(! %allHashes)
{
    die("Cannot read hashfile ", $postedPairs{"HashFile"});
}
my $display_scores;
if ($postedPairs{"DisplayScores"} =~ /True/)
{
    $display_scores=1;
}
my $letterSize;

my %wordsHash=makeHashBuf($postedPairs{"LetterText"},\$letterSize);
my $hashVecKey=makeHashVector(\%allHashes,\%wordsHash,$letterSize);

my $exactMatchNum;
my $identityScore;
my @fileList= findMessageInList($postedPairs{"ListFile"},
$hashVecKey,$postedPairs{"resultsize"},\$exactMatchNum,\$identityScore);

if($display_scores)
{
    print("Identity: ",$identityScore,"<br>\n");
}
my $fileName;
my $fileScore;
my $fileListName;
my $editedFileName;
my $matchName;
my $matchIterator;
my $matchFlag;
foreach $fileListName (@fileList)
{
    ($fileScore,$fileName)=split(/--/,$fileListName);
    if($matchIterator < $exactMatchNum) 
    {
	print("<b>");
	$matchFlag=1;
    }
    ++$matchIterator;
    $matchName="Match " . $matchIterator;
    $editedFileName=basename($fileName);
    print("<a href=\"/fraudulator/files/",$editedFileName, "\">",$matchName,"</a>");
    if($matchFlag)
    {
	print("</b>");
    }
    $matchFlag=0;
    if($display_scores)
    {
	print("&nbsp;&nbsp;&nbsp;",$fileScore);
    }
    print("<br>\n");
}

printHTMLFooter();












