#!/usr/bin/perl
###############################################################################
#
#
# Re-generate the 419 letter vector database.
#
# $Id: regen_db.pl,v 1.5 2005/03/01 21:19:22 devel Exp $
#
###############################################################################
#
#    Copyright 2005 Charles Shapiro 
#    This file is part of the Fraudulator.
#
#    The Fraudulator is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    The Fraudulator is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with the Fraudulator; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#############################################################################
use strict;
use FourNineTeen;

#
# Form variable into hash list.
#
sub makeDataList($) {

    my $buffer=$_[0];
  # Split the name-value pairs
    my @pairs = split(/&/, $buffer);
    my $pair;
    my $name;
    my $value;
    my %retList;

    foreach $pair (@pairs) 
    {
	($name, $value) = split(/=/, $pair);
	
	$value =~ tr/+/ /;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$name =~ tr/+/ /;
	$name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$retList{$name}=$value;
    }
    %retList;
}

#
# Print HTML header.
#
sub printHTMLHeader($$)
{
    my $lessNum=$_[0];
    my $moreNum=$_[1];
    # HTML header
    print("Content-type: text/html\n\n");
    print("<html><head><title>Database Regenerated</title></head>\n<body>\n");
    print("<h1>Database Regenerated.</h1>\n");
    print("<h2>For ",$lessNum," to ", $moreNum,"</h2>\n"); 

}

#
# Print the footer.
#
sub printHTMLFooter()
{
    print("\n</body>");
    print("\n</html>");
}

#
# Main Line
#

my $inBuffer;

my $inBuffer;
if ($#ARGV == -1 )
{
    read(STDIN,$inBuffer,$ENV{'CONTENT_LENGTH'});
}
else
{
    open(INPUT,"<$ARGV[0]");
    $inBuffer=<INPUT>;
    close(INPUT);
}

my %postedPairs=makeDataList($inBuffer);
opendir(LETTERS,$postedPairs{"filesDir"});
my @letterFiles=grep(!/^\./,readdir(LETTERS));
closedir(LETTERS);


my $allFilesName="/tmp/allfiles.$$";
my $fileName;
my $infilename;
my @fileContents;

open(OUTFILE, ">$allFilesName");
foreach $fileName (@letterFiles)
{
    $infilename=$postedPairs{'filesDir'} . "/" . $fileName;
    open(INFILE, "<$infilename");
    @fileContents=<INFILE>;
    close(INFILE);
    print(OUTFILE join("",@fileContents));
}
close(OUTFILE);
my $dummy;
my %tempHash=makeHash($allFilesName,\$dummy);

printHashList($postedPairs{"hashfile"},$postedPairs{"upper"},$postedPairs{"lower"},%tempHash);
my %globalHash=read_hashfile($postedPairs{"hashfile"});

my %thisHash;
my $thisHashVector;
my @hashList;
my $letterLen;
foreach $fileName (@letterFiles)
{
    $infilename=$postedPairs{'filesDir'} . "/" . $fileName;
    %thisHash=makeHash($infilename,\$letterLen);
#    print("Letter: ", $infilename, " Len: ",$letterLen,"\n");
    $thisHashVector=makeHashVector(\%globalHash,\%thisHash,$letterLen);
    
    push( @hashList, $thisHashVector . "\t" . $infilename);
}
my @outHash=sort(@hashList);
open(OUTFILE,">$postedPairs{'hashvecfile'}");
while(@outHash)
{
    print(OUTFILE $outHash[0],"\n");
    shift(@outHash);
}
close(OUTFILE);

printHTMLHeader($postedPairs{"lower"},$postedPairs{"upper"});

printHTMLFooter();











